All endpoints are classified into one of three tiers based on their computational complexity and usage frequency. The following RPS (requests per second) limits apply to all API keys:
| Tier | Description | RPS |
|---|---|---|
| Tier 1 — Critical | High-frequency, critical actions | 60 |
| Tier 2 — Moderate | Moderate-frequency, supplementary actions | 25 |
| Tier 3 — Low | Low-frequency, operational management | 10 |
When a limit is exceeded, the API returns HTTP 429 Too Many Requests with a Retry-After header indicating how many seconds to wait before retrying.
For full details on global caps, burst limits, and monthly usage, refer to your service agreement or contact your account manager.
An HTTP Response is composed by a STATUS and a BODY ( among other less important things.. ), keep in mind that should read both to have a complete understanding of what is happening. The STATUS is more important and the BODY will give you extra information.
The common HTTP Response Status Codes are used.
Status summary:
200: everything is ok. You may need to check the message with the 200 anyway in some cases to do certain thing.
4xx: you are not using our API properly. Check the message in the response body for more detail.
5xx: Our fault, Loyal Guru Api is having some error, report it to us please
When a request is not success ( Response Status is not 200 ) the Response Body has this format:
{
"error": "human readable error message",
"code": "machine friendly error"
}
When the error is related with API KEY validation the response error has this format:
{
"message": "Forbidden"
}
Every http's code the error means something different
400 Your request is not correct, some parameter is required or is not in the right format.
402 When a request is valid but does not complete successfully.
403 The api key/secret are not valid.
404 When the requested resource does not exist or cannot be found.
500 Something when wrong with our server (These are rare.).
We recommend to use HTTP Response Status code and HTTP Response Body code field to handle the errors.
Response Body error code field definitions
| code | meaning |
|---|---|
| *_not_found | The resource cannot be found. Example: customer_not_found |
| forbidden_request | The resource you were trying to reach is absolutely forbidden |
| invalid_request | The request is not valid, a parameters is missing or not valid |
| server_error | Server error |
| customer_not_enough_score | Customer haven't got enough scores for transferring |
| customer_inactive | Customer is not active so no transfers can be executed |
| voucher_redeemed | The voucher is already redeemed |
| voucher_expired | The available_to date is earlier than today |
| voucher_inactive | The coupons is not active |
| voucher_deleted | The coupon has been deleted |
| voucher_out_location | The voucher cannot be redeemed in the current location |
| voucher_out_date | The available_from date is later than today |
| voucher_not_found | The voucher not found, customer not found or voucher does not belong to customer |
| exchange_not_found | The score exchange is not found for the required location |
In case of server_error or unexpected error the Application is responsible for waiting for a period of time before issuing another request. This means that after the first error, there is a minimum back-off interval of 1 second and for each consecutive error, the back-off interval increases exponentially up to 32 seconds.
As this is a http API the "real types" that you can use are the types that allows you to send the http protocol as a parameter, these are number, string, boolean and array. So you'll see this 4 types specified along the docs in the request and response parameters of every method, but please keep in mind that your should follow this format guide.
(Number) Integer: 123 Length from 1 to 9223372036854775807
(Number) Float: 123.45 Decimal separator is dot, not coma.
(String): hello
(String) Date: 2016-12-31
(String) DateTime: 2016-12-31T23:59:43Z
(Boolean): true or false
(Array): [{"key1":123,"key2":"hello","key3":"2016-12-31T23:59:43Z"}]
(slug): ( not a proper type but.. ) A short label for something, containing only letters, numbers, underscores or hyphens. sub_family
Important notes:
Date and DateTime: you MUST ensure that you use ISO-8601 date format in UTC, so it's possible that you'll need to apply some kind of conversion to your date ( and UTC will be returned in the API ) (some documentation related). If you are not able to send UTC you should specify the offset of your DateTime ( 2016-12-31T23:59:43-0500 ), keep in mind that the offset is different depending on your timezone and date.
Regarding to the Integer type: 0 is not a valid integer
Regarding to the Integer type: 00X will be converted to X so keep in mind this if you have, for example, in your database situations in which 003 is the id of a certain resource and 3 is the id of another different resource, for us 003 and 3 is the same number.To avoid collisions between the real 001 and the real 1 in your database. For this purpose you could solve the problem by always adding to parameter a 1 prefix so the end result is 1001 and 11 and no collision between 001 converted to 1 and the real 1 will be existing
Text encoding: utf-8
Along the documentation we are not specifying DateTime or Float. You'll only see it by the example on the param. If the integer can be float you'll se an example with a float and if the Date should be a DateTime you'll see an example with a DateTime instead of a Date.
An Email header can be provided in the API requests. This email parameter will be used to register the authors of the request for a set of specific endpoints. At this moment the endpoints that register the author are:
POST /scores/transfer
POST /scores/trigger
After user authentication you can specify the expected language to our API (as part of the http-headers) in order to force the language in which the system will respond to some of the endpoints regarding multi-language content ( for example: coupons, vouchers, rewards, score transactions, challenges). Please notice that if no language is declared in the header, the system will return the default values. This only applies to companies with multilanguage feature enabled
Accept-Language: 'en'
if "Accept-Language" in header:
if "Accept-Language" language is included as part of the possible options:
return text in language of the header
else:
return text in default language of the company
else:
return default values for multilanguage fields. Ex:
The API supports idempotence for safely retrying requests without accidentally performing the same operation twice. This is useful when an API call is disrupted in transit and you do not receive a response. For example, if a request to subtract scores fails due to a network connection error, you can retry the request with the same idempotence key to guarantee that only a single subtract is done. Note that retrying a request with an idempotence key will not change the outcome of a request. When the API receives a request successfully but returns an error code, retrying it with an idempotence key will simply result in a new response with the same error code.
GET and DELETE requests are idempotent by definition, meaning that the same backend work will occur no matter how many times the same request is issued. You shouldn't send an idempotence key with these verbs because it will have no effect.
To perform an idempotent request, provide an additional Idempotency-Key:
How you create unique keys is up to you, but we suggest using V4 UUIDs or another appropriately random string. We'll always send back the same response for requests made with the same key, and keys can't be reused with different request parameters. Keys expire after 24 hours.
Idempotency-Key: 'QknyRdIN6wECfOb5'
We recommend you Postman in order to freely try this API. It's a great tool, easy to use, and you'll be able to issue every call to our API. Remember to set properly your headers.
The main resources you'll be able to manage with this API are:
Customers
Customer events
Loyalty & Gamification campaigns
Company Data
Regarding the product taxonomy system, here you'll see and example of how to represent a categorization of products in our flexible system.
+-- Taxonomy ( Family )
| +-- Feature ( Meat )
| +-- Product ( Ham )
| +-- Product ( Cow )
| +-- Product ( Horse )
| +-- ...
| +-- Feature ( Vegetables )
| +-- Product ( Tomato )
| +-- ...
| +-- Feature ( Drinks )
| +-- Product ( Coca-cola )
| +-- ...
| +-- ...
+-- Taxonomy ( Sub-Family )
| +-- Feature ( Soda )
| +-- Product ( Coca-cola )
| +-- ...
| +-- ...
+-- Taxonomy ( Section )
+-- ...
Check please the documentation of the method create activity below to have a good understanding of how a purchase activity works ( discounts, cancellations , negative and positive values... )
Some of our top resources have support for bulk fetches via "list" API methods. For instance, you can list score transactions or list of vouchers. These list API methods share a common structure with the parameter parameters: starting_after.
Loyal Guru utilizes cursor-based pagination via the starting_after parameter. You must use the response body parameter next_token_starts_after as
starting_after parameter to the next to get the next page. If the current page is the last next_token_starts_after is not present.
The order of the elements in the list could change between endpoints.
If your library doesn't support the use of a PATCH method you can always use a PUT method instead.
We strongly recommend the use of the PATCH method as the standard for this kind of actions, but we provide this alternative for older libraries.
Every call must use these three authentication headers:
X-Api-Key: api_key
X-Api-Secret: api_key_secret
X-Api-Version: 1
Please, keep in mind that you must respect Lower and Uppercase characters in the header variable name.
The api_key and the api_key_secret will be delivered by Loyal Guru, ask for them if you don't have them at info@loyal.guru.
For security reasons our system ignores all duplicated calls (same content and action) to update/delete/create elements within a 5-minutes interval.
We use the ID field of the records to avoid duplication and keep the integrity of the system. When you execute any action over a record the ID will be checked:
Insert a record with an ID that already exists will raise in real time ( not deferred ) a request error.
Delete a record with an ID than does not exist will raise in real time ( not deferred ) a request error.
Exceptions:
Activities: ID will no be checked in "POST Activities" ( it will be checked in "POST Activities/RealTime" ), so if a duplicated activity is sent will raise a deferred error and not a real time one.
Customers: apart form ID the email will also be checked.
To create a customer using the friend referral feature, check the referred_by field in the request body schema description.
Important: The updated_at field is automatically set to the current server time when creating a customer, regardless of any creation_date value provided. This ensures accurate tracking of when records are processed by the server.
Tier 2 (Moderate) — See rate limit table
| allow_duplicate_email | boolean Example: allow_duplicate_email=false Allows to create a customer with existing email. Duplicated email will be stored in duplicated_email field. If not received, default value is 'false'. |
| allow_duplicate_dni | boolean Example: allow_duplicate_dni=false Allows to create a customer with existing dni. Duplicated dni will be stored in duplicated_dni field. If not received, default value is 'false'. |
| id required | integer <int64> ID of the customer in form of an integer. It becomes optional if code is present. |
| code | string Alternatibe customer's identification in form of an Alphanumeric. It admits up to 36 characters. |
| card_id | integer <int64> When creating a unified customer, use this field to indicate the customer's card. |
| name required | string Name. |
| surname_1 | string Surname 1. |
| surname_2 | string Surname 2. |
string Email. It must be unique and it is case insensitive. It will always be saved in lowercase. | |
| phone | string Mobile phone number. An extra validation will be checked:
|
| phone_prefix | string Phone country prefix. When phone is filled phone_prefix is required |
| address | string Address. |
| address_extra | string 2 (optional, string) - Extra information about the address. |
| city | string The customer's city. |
| state | string The city's region. |
| postal_code | string Postal code. |
| birth | string Date of the birth. Must be in YYYY-MM-DD format. Years must be between 1900 and 9999 (inclusive). Birth dates with years outside this range will be automatically set to null. |
| gender | string Gender of the customer, must be one of them:
|
| document_type | string Type of document that identifies the customer. |
| dni | string Identification card number. It must be unique per customer. It will always be saved in uppercase. |
| country | string ISO 3166-1 alpha-2 country code in capital letters |
| authentication_token | string Authentication token |
| registration_location_id required | integer <int64> Registration location id. It becomes optional if registration_location_code is present. |
| registration_location_code | string Registration location code. |
| usual_location_id | integer <int64> Usual location id. It could be overriden by automatic calculations from Loyal Guru. |
| status | string Status of the customer, must be one of them:
|
| password | string Password of the customer. If not specified the system will create one. |
| password_confirmation | string Confirmation password of the customer |
| creation_date | string DateTime of the creation of the customer. The format must be ISO 8601 in UTC, e.g. '2016-01-01T20:23:20Z'. |
| sms_unsubscribe | boolean Unsubscribe status for sms campaigns |
| email_unsubscribe | boolean Unsubscribe status for email campaigns |
| push_unsubscribe | boolean Unsubscribe status for push campaigns |
| paper_free | boolean Uses digital activity or not |
| collective_id | integer <int64> Collective Id |
| collective_slug | string Collective Slug, only use it when the collective id is not used |
| communications | boolean Only true when the customer has accepted to receive communications |
| terms | boolean Only true when the customer has accepted the gdpr terms |
| profiling | boolean Only true when ther customer are allowed to share his data to make profile metrics (appear in segments, impacted by campaigns, etc) |
| terms_accepted_at | string The date when the customer accepts the gdpr terms. Can be set manually |
| profiling_accepted_at | string The date when the customer accepts the profiling. Can be set manually |
| app | boolean If customer registration is done by any mobile app |
| push_token | string Mobile app token to send notifications. Only used when app param is true. |
| custom1 | string Deprecated Use Custom value |
| custom2 | string Deprecated Use Custom value |
| custom3 | string Deprecated Use Custom value |
| custom4 | string Deprecated Use Custom value |
| custom5 | string Deprecated Use Custom value |
| custom6 | string Deprecated Use Custom value |
| custom7 | string Deprecated Use Custom value |
| custom8 | string Deprecated Use Custom value |
| custom9 | string Deprecated Use Custom value |
| custom10 | string Deprecated Use Custom value |
| custom11 | string Deprecated Use Custom value |
| custom1f | number <double> Deprecated Use Numeric custom value |
| custom2f | number <double> Deprecated Use Numeric custom value |
| custom3f | number <double> Deprecated Use Numeric custom value |
| custom4f | number <double> Deprecated Use Numeric custom value |
| custom5f | number <double> Deprecated Use Numeric custom value |
| custom6f | number <double> Deprecated Use Numeric custom value |
| custom7f | number <double> Deprecated Use Numeric custom value |
| custom8f | number <double> Deprecated Use Numeric custom value |
| kind | string Kind of customer |
| preferred_language | string ISO 639-1 preferred language for the customer |
| referred_by | integer <int64> A friend referral is registered in Loyal Guru when a customer account is created with this referrer field, which is the customer ID of the friend's account (which must be an existing ID in the Loyal Guru platform) Once a customer is created using this referred_by field, a referral event (system trigger called refer_a_friend) is triggered and can be used to reward the inviting person and the referring person with points or rewards under different conditions (defined by the created loyalty rule). See the Help Centre (Refer a Friend document) for more information. |
| fraudulent | boolean If the customer is fraudulent or not |
| third_party_consent | boolean This flag indicates whether the customer has accepted the third party data sharing. |
| attributes | object Attributes allow you to store additional data on customers. Uses the JSON Schema Form standard link.
Allowed Data Types:
Unknown Properties: Properties not defined in the schema are silently discarded - they won't cause validation errors but will NOT be stored. Case Sensitivity:
Property names are case-sensitive per JSON Schema specification. If your schema defines Attributes must be single-level only with a maximum of 50 attributes and 10KB total size. Example:
|
{- "id": 1234,
- "code": "A54fTr1",
- "name": "Jon",
- "surname_1": "Snow",
- "surname_2": "Sand",
- "email": "jon@winter.com",
- "phone": "678123456",
- "phone_prefix": "34",
- "address": "Snow Tree",
- "address_extra": "31 1",
- "postal_code": "08110",
- "birth": "2016-01-01",
- "gender": "feminine",
- "document_type": "dni",
- "dni": "53023040B",
- "country": "ES",
- "authentication_token": "y78rhr29feuyfw89",
- "registration_location_id": 123,
- "status": "active",
- "password": "mysecretpassword",
- "password_confirmation": "mysecretpassword",
- "creation_date": "2016-01-01T20:23:20Z",
- "sms_unsubscribe": true,
- "email_unsubscribe": true,
- "push_unsubscribe": true,
- "paper_free": false,
- "collective_id": 17,
- "collective_slug": "employees",
- "communications": true,
- "terms": true,
- "profiling": true,
- "terms_accepted_at": "2016-01-02T15:04:05Z",
- "profiling_accepted_at": "2016-01-02T15:04:05Z",
- "app": false,
- "push_token": "cd9fea48-c2c4-ab88-d4ef-db1f7288af92",
- "custom1": "custom value 1",
- "custom2": "custom value 2",
- "custom3": "custom value 3",
- "custom4": "custom value 4",
- "custom5": "custom value 5",
- "custom6": "custom value 6",
- "custom7": "custom value 7",
- "custom8": "custom value 8",
- "custom9": "custom value 9",
- "custom10": "custom value 10",
- "custom11": "custom value 11",
- "kind": "ecommerce",
- "preferred_language": "es",
- "referred_by": 1234,
- "fraudulent": false,
- "third_party_consent": true,
- "attributes": {
- "loyalty_tier": "gold",
- "customer_score": 850,
- "newsletter_opt_in": true,
- "tags": [
- "vip",
- "premium",
- "early_adopter"
], - "preferred_store_ids": [
- 101,
- 205,
- 308
], - "interests": [
- "electronics",
- "fashion",
- "sports"
]
}
}{- "status": "success"
}Get a list of customers, filtered by ID and/or phone number.
Usage of the parameters:
ids or phones must be present to get the list of customers. Otherwise, the API returns an error.ids and phones can be sent at the same time.Tier 3 (Low) — See rate limit table
| ids | string Example: ids=123,456 List of IDs to be used for filtering. If there are more than one, they should be separated by commas. |
| phones | string Example: phones=666777888,666777999 List of phone numbers to be used for filtering. If there are more than one, they should be separated by commas. |
{- "list": [
- {
- "dni": "12345678A",
- "name": "Jon",
- "surname_1": "Snow",
- "surname_2": "Sand",
- "email": "jon@example.com",
- "birth": "1990-12-31",
- "phone_prefix": "34",
- "status": "active",
- "phone": "600600600",
- "address": "Calle ABC, 10",
- "address_extra": "-",
- "postal_code": "55555",
- "city": "Barcelona",
- "state": "Catalonia",
- "id": "123",
- "trimestral_expend": 123,
- "score": 100,
- "score_available": 80,
- "paper_free": true,
- "merged": true,
- "preferred_language": "es",
- "registration_location_id": 1234,
- "registration_location_code": "S22C-Plaza",
- "fraudulent": false,
- "collective_id": 123,
- "attributes": {
- "membership_level": "premium",
- "points_balance": 1250
}
}
]
}The field and value to look for in the body of the POST request. The fields that can be searched are: id, code, dni, associate_id, email.
Tier 3 (Low) — See rate limit table
| id | integer <int64> Customer ID, exclusive with other search params. |
| code | string Customer Code, exclusive with other search params. |
| dni | string Customer DNI, exclusive with other search params. |
| associate_id | integer <int64> Customer Associate ID, exclusive with other search params. |
string Customer Email, exclusive with other search params |
{- "id": 123
}{- "id": 123,
- "code": "A54fTr1",
- "dni": "00000000T",
- "name": "Jon",
- "surname_1": "Snow",
- "surname_2": "Sand",
- "email": "jon@example.com",
- "birth": "1985-06-15",
- "phone_prefix": "+1",
- "phone": "555123456",
- "status": "active",
- "address": "123 Main Street",
- "address_extra": "Apt 4B",
- "postal_code": "10001",
- "city": "New York",
- "state": "NY",
- "trimestral_expend": 123,
- "score": 100,
- "score_available": 80,
- "paper_free": true,
- "merged": true,
- "merged_to": 321,
- "kind": "ecommerce",
- "preferred_language": "es",
- "communications": true,
- "app": false,
- "registration_location_id": 5678,
- "registration_location_code": "NYC-Downtown",
- "fraudulent": false,
- "collective_id": 456,
- "attributes": {
- "search_verified": true,
- "engagement_score": 95
}
}Tier 1 (Critical) — See rate limit table
| value required | string Example: 1234,53345345B Could be an integer or a string. Search options are as follows:
|
| search_param required | string Example: search_param=id,code,dni,email The param field used for the customer search. |
{- "id": "123",
- "code": "A54fTr1",
- "name": "Jon",
- "surname_1": "Snow",
- "surname_2": "Sand",
- "email": "jon@example.com",
- "phone_prefix": "+34",
- "phone": "600600600",
- "address": "Calle ABC, 10",
- "address_extra": "-",
- "postal_code": "55555",
- "city": "Barcelona",
- "state": "Catalonia",
- "trimestral_expend": 123,
- "score": 100,
- "score_available": 80,
- "paper_free": true,
- "merged": true,
- "merged_to": 321,
- "kind": "ecommerce",
- "preferred_language": "es",
- "communications": true,
- "app": false,
- "dni": "12345678Z",
- "birth": "1990-12-31",
- "custom1": "custom 1 value",
- "custom2": "custom 2 value",
- "custom3": "custom 3 value",
- "custom4": "custom 4 value",
- "custom5": "custom 5 value",
- "custom6": "custom 6 value",
- "custom7": "custom 7 value",
- "custom8": "custom 8 value",
- "custom9": "custom 9 value",
- "custom10": "custom 10 value",
- "custom11": "custom 11 value",
- "custom1f": "custom 1f value",
- "custom2f": "custom 2f value",
- "custom3f": "custom 3f value",
- "custom4f": "custom 4f value",
- "custom5f": "custom 5f value",
- "custom6f": "custom 6f value",
- "custom7f": "custom 7f value",
- "custom8f": "custom 8f value",
- "status": "active",
- "registration_location_id": 1234,
- "registration_location_code": "S22C-Plaza",
- "fraudulent": false,
- "collective_id": 123,
- "third_party_consent": true,
- "attributes": {
- "loyalty_tier": "gold",
- "customer_score": 850,
- "vip_status": true
}
}Important: The updated_at field in the request body is now deprecated and ignored. The system automatically sets updated_at to the current server time for all customer updates. This ensures data consistency and accurate tracking of record modifications for downstream systems.
Attributes Validation: For the attributes field, only the incoming attributes in your request are validated against the schema. Existing attributes stored on the customer are NOT re-validated. This means:
Tier 2 (Moderate) — See rate limit table
| value required | integer <int64> Could be an integer or a string.
|
| search_param | string Example: search_param=id Field used to update customer. Valid fields: (id, code) |
| allow_duplicate_email | boolean Example: allow_duplicate_email=false Allows to update a customer with existing email. Duplicated email will be stored in duplicated_email field. If not received, default value is 'false'. |
| allow_duplicate_dni | boolean Example: allow_duplicate_dni=false Allows to update a customer with existing dni. Duplicated dni will be stored in duplicated_dni field. If not received, default value is 'false'. |
| name | string Name. |
| surname_1 | string Surname 1. |
| surname_2 | string Surname 2. |
string Email. It must be unique and it is case insensitive. It will always be saved in lowercase. | |
| phone | string Mobile phone number. An extra validation will be checked:
|
| phone_prefix | string Phone country prefix. When phone is filled phone_prefix is required. |
| address | string Address. |
| address_extra | string 2 (optional, string) - Extra information about the address. |
| city | string The customer's city. |
| state | string The city's region. |
| postal_code | string Postal code. |
| birth | string Date of the birth. Must be in YYYY-MM-DD format. Years must be between 1900 and 9999 (inclusive). Birth dates with years outside this range will be automatically set to null. |
| gender | string Gender of the customer, must be one of them:
|
| document_type | string Type of document that identifies the customer. |
| dni | string Identification card number. It will always be saved in uppercase. |
| country | string ISO 3166-1 alpha-2 country code in capital letters |
| authentication_token | string Authentication token |
| registration_location_id | integer <int64> Registration location id. |
| registration_location_code | string Registration location code. |
| usual_location_id | integer <int64> Usual location id. It could be overriden by automatic calculations from Loyal Guru. |
| status | string Status of the customer, must be one of them:
|
| creation_date | string DateTime of the creation of the customer. The format must be ISO 8601 in UTC, e.g. '2016-01-01T20:23:20Z'. |
| sms_unsubscribe | boolean Unsubscribe status for sms campaigns |
| email_unsubscribe | boolean Unsubscribe status for email campaigns |
| push_unsubscribe | boolean Unsubscribe status for push campaigns |
| paper_free | boolean Uses digital activity or not |
| collective_id | integer <int64> Collective Id |
| collective_slug | string Collective Slug, only use it,when the collective id is not used |
| communications | boolean Only true when the customer has accepted to receive communications |
| terms | boolean Only true when the customer has accepted the gdpr terms |
| profiling | boolean Only true when ther customer are allowed to share his data to make profile metrics (appear in segments, impacted by campaigns, etc) |
| terms_accepted_at | string The date when the customer accepts the gdpr terms. Can be set manually |
| profiling_accepted_at | string The date when the customer accepts the profiling. Can be set manually |
| app | boolean If customer registration is done by any mobile app |
| push_token | string Mobile app token to send notifications. Only used when app param is missing, null or true. |
| custom1 | string Deprecated Use Custom value |
| custom2 | string Deprecated Use Custom value |
| custom3 | string Deprecated Use Custom value |
| custom4 | string Deprecated Use Custom value |
| custom5 | string Deprecated Use Custom value |
| custom6 | string Deprecated Use Custom value |
| custom7 | string Deprecated Use Custom value |
| custom8 | string Deprecated Use Custom value |
| custom9 | string Deprecated Use Custom value |
| custom10 | string Deprecated Use Custom value |
| custom11 | string Deprecated Use Custom value |
| custom1f | number <double> Deprecated Use Numeric custom value |
| custom2f | number <double> Deprecated Use Numeric custom value |
| custom3f | number <double> Deprecated Use Numeric custom value |
| custom4f | number <double> Deprecated Use Numeric custom value |
| custom5f | number <double> Deprecated Use Numeric custom value |
| custom6f | number <double> Deprecated Use Numeric custom value |
| custom7f | number <double> Deprecated Use Numeric custom value |
| custom8f | number <double> Deprecated Use Numeric custom value |
| kind | string Kind of customer |
| preferred_language | string ISO 639-1 preferred language for the customer |
| fraudulent | boolean If the customer is fraudulent or not |
| attributes | object Attributes allow you to store additional data on customers. Uses the JSON Schema Form standard link.
Update Behavior (JSON Merge Patch):
Case Sensitivity:
Property names are case-sensitive per JSON Schema specification. If your schema defines Validation Timing:
Allowed Data Types:
Attributes must be single-level only with a maximum of 50 attributes and 10KB total size. Example:
|
{- "name": "Jon",
- "surname_1": "Snow",
- "surname_2": "Sand",
- "email": "jon@winter.com",
- "phone": "678123456",
- "phone_prefix": "34",
- "address": "Snow Tree",
- "address_extra": "31 1",
- "postal_code": "08110",
- "birth": "2016-01-01",
- "gender": "feminine",
- "document_type": "dni",
- "dni": "53023040B",
- "country": "ES",
- "authentication_token": "y78rhr29feuyfw89",
- "registration_location_id": 123,
- "registration_location_code": "loc_cod_001",
- "usual_location_id": 123,
- "status": "active",
- "creation_date": "2016-01-01T20:23:20Z",
- "sms_unsubscribe": true,
- "email_unsubscribe": true,
- "push_unsubscribe": true,
- "paper_free": false,
- "collective_id": 17,
- "collective_slug": "employees",
- "communications": true,
- "terms": true,
- "profiling": true,
- "terms_accepted_at": "2016-01-02T15:04:05Z",
- "profiling_accepted_at": "2016-01-02T15:04:05Z",
- "app": false,
- "push_token": "cd9fea48-c2c4-ab88-d4ef-db1f7288af92",
- "custom1": "custom value 1",
- "custom2": "custom value 2",
- "custom3": "custom value 3",
- "custom4": "custom value 4",
- "custom5": "custom value 5",
- "custom6": "custom value 6",
- "custom7": "custom value 7",
- "custom8": "custom value 8",
- "custom9": "custom value 9",
- "custom10": "custom value 10",
- "custom11": "custom value 11",
- "kind": "ecommerce",
- "preferred_language": "es",
- "fraudulent": false,
- "attributes": {
- "loyalty_tier": "gold",
- "customer_score": 850,
- "newsletter_opt_in": true,
- "tags": [
- "vip",
- "premium",
- "early_adopter"
], - "preferred_store_ids": [
- 101,
- 205,
- 308
], - "interests": [
- "electronics",
- "fashion",
- "sports"
]
}
}{- "status": "success"
}Deletes a customer definitely or empty it according to the 'hard' variable
There are two delete modes according to the 'hard' variable
If the 'hard' variable is true, it will execute the hard delete mode.
- This mode deletes definitely the customer if he/she hasn't any critical relation.
The critical relations are:
· activities
· cashback
· redemptions
· score transactions
· tag customers
· vouchers
If the customer have critical relations, is not possible to do the hard delete but the soft delete will be done
Otherwise if the 'hard' variable is false, it will execute the soft delete mode.
- This mode empty the customer and deletes some relations with them.
The customer still exists so the id is not possible to use in other customer.
**Important**: A customer cannot be deleted while in "merging" status. If a delete request is made for a customer with status "merging", the API will return a 409 CONFLICT error.
Tier 3 (Low) — See rate limit table
| value required | integer <int64 or string> Example: 12 ID of the customer |
| hard required | boolean Example: hard=true Defines the hard mode |
| search_param | string Example: search_param=id Field used to update customer. Valid fields: (id, code) |
| Content-Type required | string Value: "application/json" Example: application/json |
{- "status": "success"
}Get the list of customer attributes for a customer
Tier 3 (Low) — See rate limit table
| id required | integer <int64> Example: 123 Id of the customer |
| attribute_type | string Example: attribute_type=calculation Attribute type of the customer attribute to list. Mutually exclusive with attribute_id. |
| attribute_id | integer <int64> Example: attribute_id=3214 Attribute definition id of the customer attribute to list. Mutually exclusive with attribute_type. |
| name | string Example: name=attr Name to search the customer attribute list. It's not case-sensitive and does not require an exact match. |
| system | boolean Example: system=true Define system to search the customer attribute list. |
| per_page | integer <int64> Example: per_page=20 Max number of attributes returned per response. - Default: 10 |
| starting_after | string Example: starting_after=token Yo will receive this token on every response ( on the variable next_token_starts_after ) in order to have the next batch of elements. |
{- "data": [
- {
- "name": "Max cost",
- "value": "50.6",
- "data_type": "float",
- "attribute_type": "calculation",
- "slug": "max_cost",
- "system": true,
- "created_at": "2018-09-04T16:19:25.343+02:00"
}
], - "next_token_starts_after": "token"
}Retrieve an array of all active program tiers related to the customer. This includes program tiers specific to the customer's country and those not assigned to any country (program tiers available for the entire customer database).
Only program tiers relevant to the customer's country and currently active will be included in the response.
Check out the following links that can help you:
Tier 3 (Low) — See rate limit table
| id | integer Could be an integer or a string.
|
| search_param | string Default: "id" Example: search_param=code The param field used for the customer search. Possible options: "id" and "code" |
{- "data": [
- {
- "id": 1,
- "name": "Avg. Spend",
- "countries": [
- "ES"
], - "current_level_name": "Bronze",
- "current_level": 1,
- "attribute_value": 50,
- "won_at": "2021-05-01T15:00:00Z",
- "expires_at": "2021-12-31T23:59:59Z",
- "to_reach_next_level_value": 50,
- "to_reach_next_level_name": "Silver",
- "structure": [
- {
- "level": 1,
- "name": "Bronze",
- "threshold": 0
}, - {
- "level": 2,
- "name": "Silver",
- "threshold": 100
}, - {
- "level": 3,
- "name": "Gold",
- "threshold": 200
}
]
}, - {
- "id": 2,
- "name": "Scores",
- "countries": [
- "ES",
- "FR"
], - "current_level_name": "Gold",
- "current_level": 3,
- "attribute_value": 250,
- "won_at": "2021-05-01T15:00:00Z",
- "expires_at": "2021-12-31T23:59:59Z",
- "structure": [
- {
- "level": 1,
- "name": "Bronze",
- "threshold": 0
}, - {
- "level": 2,
- "name": "Silver",
- "threshold": 100
}, - {
- "level": 3,
- "name": "Gold",
- "threshold": 200
}
]
}
]
}/customers/{id}/segment_validation is also available as a LEGACY version of this API.
Get the result of checking if a customer belongs to a segment
Tier 3 (Low) — See rate limit table
| id required | string |
| segment_id required | integer <int64> Example: segment_id=1234 The segment ID |
{- "result": true
}/customers/{id}/segments is also available as a LEGACY version of this API.
Get the list of segments which the customer belongs to.
Tier 3 (Low) — See rate limit table
| id required | string |
{- "list": [
- {
- "segment_id": 1234
}, - {
- "segment_id": 5678
}
]
}Tier 3 (Low) — See rate limit table
| customer_id required | integer <int64> ID of the customer in form of an integer. |
| associate_customer_id required | integer <int64> ID of the associate customer in form of an integer. |
| relationship_type | string It is the kind of relationship between both customers. |
| active | boolean Status of the association. If not provided the association will be created as active=true by default. |
| main | boolean Indicates the main association. If not provided will be created as main=false by default. |
{- "customer_id": 1234,
- "associate_customer_id": 4321,
- "relationship_type": "default",
- "active": true,
- "main": true
}{- "id": 1,
- "customer_id": 1234,
- "associate_customer_id": 4321,
- "relationship_type": "default",
- "active": true,
- "main": true,
- "created_at": "2021-09-22T14:02:06.708121Z",
- "updated_at": "2021-09-22T14:02:06.708121Z"
}Updates the relationship type of the active association between provided customers.
Tier 3 (Low) — See rate limit table
| customer_id required | integer <int64> ID of the customer in form of an integer. |
| associate_customer_id required | integer <int64> ID of the associate customer in form of an integer. |
| relationship_type required | string It is the kind of relationship between both customers. |
| main | boolean Indicates the main association. If not provided will not change. |
{- "customer_id": 1234,
- "associate_customer_id": 4321,
- "relationship_type": "default",
- "main": true
}{- "status": "success"
}Sets as inactive the active association between provided customers.
Tier 3 (Low) — See rate limit table
| customer_id required | integer <int64> Example: customer_id=1234 ID of the customer in form of an integer. |
| associate_customer_id required | integer <int64> Example: associate_customer_id=4321 ID of the associate customer in form of an integer. |
| Content-Type required | string Value: "application/json" Example: application/json |
{- "status": "success"
}Tier 3 (Low) — See rate limit table
| id required | string |
| active required | boolean Example: active=true Status of the association between the customer and the associates to list. If not provided, it will be true by default. |
| Content-Type required | string Value: "application/json" Example: application/json |
{- "list": [
- {
- "id": 1,
- "customer_id": 999050031793530,
- "associate_customer_id": 999050032283499,
- "relationship_type": null,
- "active": true,
- "created_at": "2021-09-22T10:45:32.40923Z",
- "updated_at": "2021-09-22T10:45:32.40923Z"
}, - {
- "id": 2,
- "customer_id": 999050031793530,
- "associate_customer_id": 999050032283689,
- "relationship_type": "merge",
- "active": true,
- "merge_id": 1,
- "created_at": "2021-09-22T14:02:06.708121Z",
- "updated_at": "2021-09-22T14:02:06.708121Z",
- "main": true
}
]
}Create a new card associated to a customer
Tier 3 (Low) — See rate limit table
| id required | integer ID of the customer |
| id | integer Id of the new card |
| main | boolean Indicates the main association. |
| motive | string It is the motive for creation of the new card. |
| relationship_type | string It is the kind of relationship between customer and the new card. |
{- "id": 331,
- "main": true,
- "motive": "default",
- "relationship_type": "default"
}{- "status": "success"
}Executes a merge between two customers. This is the detailed actions done during a merge operation:
- set the old customer's status to "merging" immediately (protects against deletion during merge)
- create an associate record related to both customers
- reassign all associated records to the new customer. Entities involved: activities, campaign_content_customers, cashbacks, loyalty_score_vouchers, redemptions, relatives, scores, score_expenses, score_transactions, vouchers
- set the old customer as the associated in all the transferred activities
- set the old customer's status to "merged" so it cannot be targeted by segments
Personal data (such as name, phone number, email...) is not transferred nor erased in the old customer.
New customer keeps all previous associated records they had. The merge operation is just 'appending' data to them.
**Status Flow**: active/inactive → merging → merged
The transference won't take place when:
- the old customer is already merged or merging
- the new customer is already merged
Tier 3 (Low) — See rate limit table
| old_customer_id | number The customer id you want to transfer data from. Exactly one of old_customer_id or old_customer_code must be given. |
| new_customer_id | number The customer id that is going to recieve the data. Exactly one of new_customer_id or nw_customer_code must be given. |
| old_customer_code | string The customer code you want to transfer data from. Exactly one of old_customer_id or old_customer_code must be given. |
| new_customer_code | string The customer code that is going to recieve the data. Exactly one of new_customer_id or nw_customer_code must be given. |
| relationship_type | string It is the kind of relationship between both customers. |
| motive | string It is the motive for merging these two customers. |
{- "old_customer_id": 292247,
- "new_customer_id": 188976,
- "old_customer_code": "292247",
- "new_customer_code": "188976",
- "relationship_type": "\"default\"",
- "motive": "\"default\""
}{- "status": "success"
}Breaks customer association with its parent one. Only customers with not empty "merged_to" field can be unmerged.
- Set association "active" field to false.
- Create a record in customer_merge_logs with unmerge information using association merge_id field as an origin_merge_id
- Change associated customer status field to active
- Unset merge_to field fron associated customer.
- If with_activites flag is set to true, all the activities that were transferred to the parent will be reassigned to the associate, otherwise they will be kept in the parent customer.
Tier 3 (Low) — See rate limit table
| associate_id required | integer <int64> Example: 1234 ID of the customer in form of an integer. If sent a string and |
| with_activites required | boolean Example: with_activites=true Flag for indicating if activities must be reassigned to the associate or kept in the parent customer.
Default: |
| search_param | string Example: search_param=id,code The param field used for the customer search. In case it is not present or invalid, the default value will be id. |
| Content-Type required | string Value: "application/json" Example: application/json |
{- "status": "success"
}Transfers the data related to a customer to a newly created customer.
The old customer's status is set to "merging" immediately when the request is received, protecting it from deletion during the merge process. Once the merge completes (asynchronously), the status is set to "merged".
**Status Flow**: active/inactive → merging → merged
The transference won't take place when:
- the old customer is already merged or merging
- there is an active association between the customers
Tier 3 (Low) — See rate limit table
| X-Api-Key required | string Value: "api_key" Example: api_key |
| X-Api-Secret required | string Value: "api_key_secret" Example: api_key_secret |
| X-Api-Version required | string Value: "1" Example: 1 |
| old_customer_id | number The customer id you want to transfer data from. Exactly one of old_customer_id or old_customer_code must be given. |
| new_customer_id | number The customer id that is going to recieve the data. Exactly one of new_customer_id or nw_customer_code must be given. |
| old_customer_code | string The customer code you want to transfer data from. Exactly one of old_customer_id or old_customer_code must be given. |
| new_customer_code | string The customer code that is going to recieve the data. Exactly one of new_customer_id or nw_customer_code must be given. |
| relationship_type | string It is the kind of relationship between both customers. |
| motive | string It is the motive for merging these two customers. |
{- "old_customer_id": 292247,
- "new_customer_id": 188976,
- "old_customer_code": "292247",
- "new_customer_code": "188976",
- "relationship_type": "default",
- "motive": "default"
}{- "status": "success"
}/activities/realtime is also available as a LEGACY version of this API.
An "Activity" in Loyal Guru primarily represents a purchase event, often referred to as a "cart" or "ticket." This method focuses on the real-time creation of such cart events.
Purpose of this method (Real-time Cart Creation): This method allows you to create a new cart in real-time. It's designed for immediate processing and to provide insights upon creation.
Key Uses & Benefits:
Promotions and Discounts (coupons_desired property):
By default, all massive and loyalty member promotions (points and discounts) without coupon are included and applied when calculating the ticket.
You can control how vouchers are applied using the coupons_desired property:
all: Apply all masive + loyalty member promotions + all vouchers assigned to the customer.selected: Apply all massive + loyalty member promotions + only vouchers previously selected by the customer via the appropriate endpoint.["34433", "465443"]: apply all massive + loyalty member promotions without coupon + the vouchers/static code specified.[] (empty array) or omit property: Apply only all massive and loyalty member promotions without coupon (no specific vouchers)..Data Integrity and Coherence (Important Caveats):
cart.total equals sum of line.totals,
customer_id exists). If you send incoherent data, the endpoint will
process everything anyway, and the customer WILL get their points.Important Method Logic & Considerations:
total amount returned for cart lines is adjusted after applying
all relevant discounts (promotional campaigns, vouchers, point-based
discounts/cashback).original_total attribute.quantity field): Lines are only accepted for return if the
quantity is less than or equal to the original cart line quantity. If
different, the response will be an error. You are allowed to return the
same original line across different activities.original_total
(50% by default). The final total for a line must be divisible by its
quantity with no more than two decimal places. Similarly, the points
allocated to a line must be divisible by its quantity without decimals.customer_id and customer_code are mutually
exclusive; use only one.Cart Structure Summary:
total field representing the exact amount paid by the
customer for the entire cart, including taxes and applied discounts.total field representing the exact amount paid for
that specific line, including taxes and applied discounts.total field in a cart and a line should be negative if the cart
is a cart cancellation. The same applies to the quantity field within a line.international: true
field will be included in all cart responses. If both currencies are the
same, this field will not be shown.Tier 1 (Critical) — See rate limit table
| id | integer <int64> ID of the cart in form of an integer. |
| code | string Identification |
| location_id | integer <int64> ID of the location in form of an integer. |
| location_code | string Code of the location. |
| customer_id | integer <int64> ID of the customer in form of an integer. Mutually exclusive with |
| customer_code | string Alphanumeric customer code. It must be unique and existing in ours system. Mutually exclusive with |
| creation_date required | string DateTime of the creation of the cart. |
| total required | number Total amount of the purchase cart payed by the customer ( dsscounts applied, taxes included ). If the cart is a cancellation this amount should be negative. The sum of the total values of the activities should be equal to the total sales of the company. |
| original_total | number Original total amount of the purchase cart before any discount or cashback applied before evaluation of the ticket in LG. This value never changes in the different evaluations of the same ticket, and it is used to calculate the total discount applied on the ticket. |
| currency | string Code of the currency acording to the ISO 4217(It must be Capitals letters). In the absence of any information on this point, is going to be filled with the default company currency setup. |
| cashback_score_desired | number The total amount of points that you'd like to spend on the purchase, if specified a cashback array will appear on the response showing how the points were distributed qithin the cart lines. And also, the total of every line will be modifyied acording this array. Use this param or cashbacks array, but you can's use both. If you don't want to deal with specifying exactly the amount of points for the cashback but you'd like to force the maximum redemption of points available for a certain customer, you can specify "-1". (50% maximum discount by default per each line will be applied) |
| vouchers_desired | Array of arrays Deprecated Use
|
| coupons_desired | Array of arrays By default, all massive and loyalty member promotions (points and discounts) are included and applied when calculating the ticket. You can control how vouchers are applied using the |
required | Array of objects (LineActivity) Array of lines, at least one is required. |
Array of objects (Cashback) Array of cashbacks. Use this param or cashback_score_desired, but you can's use both. | |
Array of objects (Return) Array of returns. | |
Array of objects (PromotionV2) Array with applied promotions. Important: this is only an informative field, you can't apply a promotion through this field. | |
string or object Deprecated | |
string or object Deprecated | |
string or object Deprecated | |
string or object Deprecated | |
string or object Deprecated | |
string or object Deprecated | |
string or object Deprecated | |
string or object Deprecated | |
| business_name | string The company's corporate name. |
| total_net | number Total amount of money paid by the customer, excluding taxes. |
| total_tax | number Total amount of taxes paid by the customer. |
| tpv_id | string Alphanumeric identifier of the PoS terminal where the cart is made. |
| staff_name | string Name of the person on the PoS terminal. |
| order_id | string Alphanumeric identifier of the order the cart belongs to. |
Array of objects (Payment) Details how the cart amount is paid. | |
object (Shipment) | |
| checkout_date | string DateTime of the checkout of the cart. |
| payment_cost | number Total amount of payment cost paid by the customer. |
| shipping_cost | number Total amount of shipping cost paid by the customer. |
| channel | string Channel from which the cart comes. |
| attributes | object Attributes allow you to store additional data on activities. Uses the JSON Schema Form standard link.
Allowed Data Types:
Unknown Properties: Properties not defined in the schema are silently discarded - they won't cause validation errors but will NOT be stored. Case Sensitivity:
Property names are case-sensitive per JSON Schema specification. If your schema defines Attributes must be single-level only with a maximum of 50 attributes and 10KB total size. Example:
|
| additional_costs | object It allows you to store additional costs associated with the cart.
Limits:
Example:
|
| apply_discounts | boolean It allows you to decide whether discounts should be applied to the cart or not. By default, discounts are applied to the cart. If you set this parameter to false, no discount will be applied to the cart, but points discount will be applied if |
| apply_points | boolean It allows you to decide whether points campaigns should be applied to the cart or not. By default, points are given to the customer according to the points campaigns configured in the platform. If you set this parameter to false, no points campaign will be given through the cart. This parameter doesn't affect the redemption of points specified through |
{- "id": 1234,
- "code": "1a2b3c4d",
- "location_id": 12,
- "location_code": "12A",
- "customer_id": 8223,
- "customer_code": "8223a",
- "creation_date": "2016-01-01T23:43:20Z",
- "total": 1234,
- "original_total": 1234,
- "currency": "EUR",
- "cashback_score_desired": 123,
- "vouchers_desired": [
- "selected"
], - "coupons_desired": [
- "selected"
], - "lines": [
- {
- "order": 1,
- "product_id": 345,
- "product_code": "0015SJ1L",
- "product_ean": "GHT567A",
- "total": 12.67,
- "original_total": 12.67,
- "total_cost": 9.67,
- "quantity": 1.2,
- "measurement_unit": "g",
- "total_net": 1200,
- "total_tax": 34,
- "product_name": "Soda juice 1l",
- "product_tax": 21,
- "custom1": "custom value 1",
- "custom2": "custom value 2",
- "custom3": "custom value 3",
- "custom4": "custom value 4",
- "custom5": "custom value 5",
- "custom6": "custom value 6",
- "custom7": "custom value 7",
- "supplier_id": 9876,
- "attributes": {
- "warranty_selected": true,
- "gift_wrap": false,
- "add_on_ids": [
- 10,
- 20,
- 30
], - "special_instructions": "Handle with care",
- "product_condition": "new",
- "return_policy_applied": true
}, - "additional_costs": {
- "cost1": 1.17,
- "cost2": 2.99
}
}
], - "cashbacks": [
- {
- "line_order": 1,
- "score": 1234,
- "discount": 1267
}
], - "returns": [
- {
- "ticket_id": 1234,
- "ticket_code": "1a2b3c4d",
- "line_order": 1,
- "from_line_order": 3,
- "quantity": 1,
- "line_order_change": 1
}
], - "promotions": [
- {
- "promotion_id": 1234,
- "discount": 12.6,
- "line_order": 1,
- "product_id": 2
}
], - "custom1": "custom value",
- "custom2": "custom value",
- "custom3": "custom value",
- "custom4": "custom value",
- "custom5": "custom value",
- "custom6": "custom value",
- "custom7": "custom value",
- "custom8": "custom value",
- "business_name": "SuperMarket S.L. Spain",
- "total_net": 1200,
- "total_tax": 34,
- "tpv_id": "A55",
- "staff_name": "John Doe",
- "order_id": "Order 1234A",
- "payments": [
- {
- "amount": 15,
- "type": "cash",
- "change": 5
}
], - "shipment": {
- "status": "some_status",
- "tracking_code": "some_code",
- "delivery_address": "some_address",
- "company": "some_company",
- "tracking_url": "some_url"
}, - "checkout_date": "2016-01-01T23:43:20Z",
- "payment_cost": 1.5,
- "shipping_cost": 5.5,
- "channel": "online",
- "attributes": {
- "warranty_selected": true,
- "gift_wrap": false,
- "add_on_ids": [
- 10,
- 20,
- 30
], - "special_instructions": "Handle with care",
- "product_condition": "new",
- "return_policy_applied": true
}, - "additional_costs": {
- "cost1": 1.17,
- "cost2": 2.99
}, - "apply_discounts": true,
- "apply_points": false
}{- "id": 123456,
- "code": "ACT-123456",
- "creation_date": "2025-06-01T12:00:00Z",
- "location_id": 98765,
- "total": 100.5,
- "original_total": 150.75,
- "score": 100,
- "score_as_money": 12.65,
- "score_used": 120,
- "score_used_as_money": 12.65,
- "score_returned_from_customer": 12,
- "score_returned_from_customer_as_money": 1.25,
- "score_returned_to_customer": 12,
- "score_returned_to_customer_as_money": 1.25,
- "total_scores_coupon_applied": 116,
- "total_scores_coupon_applied_as_money": 1.16,
- "total_discount_voucher_applied": 11.2,
- "total_discount_applied": 11.2,
- "lines": [
- {
- "order": 1,
- "product_id": 345,
- "product_code": "0015SJ1L",
- "product_ean": "GHT567A",
- "total": 12.67,
- "original_total": 12.67,
- "total_cost": 9.67,
- "quantity": 1.2,
- "measurement_unit": "g",
- "total_net": 1200,
- "total_tax": 34,
- "product_name": "Soda juice 1l",
- "product_tax": 21,
- "custom1": "custom value 1",
- "custom2": "custom value 2",
- "custom3": "custom value 3",
- "custom4": "custom value 4",
- "custom5": "custom value 5",
- "custom6": "custom value 6",
- "custom7": "custom value 7",
- "supplier_id": 9876,
- "attributes": {
- "warranty_selected": true,
- "gift_wrap": false,
- "add_on_ids": [
- 10,
- 20,
- 30
], - "special_instructions": "Handle with care",
- "product_condition": "new",
- "return_policy_applied": true
}, - "additional_costs": {
- "cost1": 1.17,
- "cost2": 2.99
}
}
], - "customer": [
- {
- "id": 1,
- "score": 1234,
- "score_as_money": 12.34,
- "score_available": 1204,
- "score_available_as_money": 12.04,
- "score_threshold_cashback": 1000,
- "score_threshold_cashback_as_money": 100,
- "money_threshold_cashback": 10,
- "score_to_reach_cashback": 100,
- "money_to_spend_to_reach_cashback": 0.1,
- "fraudulent": false,
- "attributes": {
- "loyalty_tier": "gold",
- "customer_score": 850,
- "newsletter_opt_in": true,
- "tags": [
- "vip",
- "premium",
- "early_adopter"
], - "preferred_store_ids": [
- 101,
- 205,
- 308
], - "interests": [
- "electronics",
- "fashion",
- "sports"
]
}
}
], - "effects": [
- {
- "rule_id": 2322,
- "line": 1,
- "rule_name": "Product Discount",
- "type": "discount",
- "effect_type": "percentage",
- "distribution_type": "individual_items",
- "select_customers": "loyalty",
- "value": 100
}, - {
- "rule_id": 2323,
- "line": -1,
- "rule_name": "Holiday Points Bonus",
- "type": "points",
- "effect_type": "direct_value",
- "distribution_type": "total",
- "select_customers": "all_customers",
- "value": 600,
- "value_as_money": 6,
- "available_from": "2025-06-01",
- "available_to": "2026-05-30"
}, - {
- "rule_id": 2324,
- "line": 2,
- "rule_name": "Combo Meal Deal",
- "type": "discount",
- "effect_type": "combo_price",
- "distribution_type": "individual_items_pro_rata",
- "select_customers": "targeted",
- "value": 400,
- "coupon_info": {
- "voucher_id": 111,
- "voucher_code": "4344fjaa",
- "coupon_id": 122211,
- "coupon_name": "Combo Meal Deal"
}
}, - {
- "rule_id": 2325,
- "line": 3,
- "rule_name": "Cashback Offer",
- "type": "points",
- "effect_type": "ratio",
- "distribution_type": "total",
- "select_customers": "loyalty",
- "value": 600,
- "value_as_money": 6,
- "available_from": "2025-06-01",
- "available_to": "2026-05-30"
}, - {
- "type": "discount",
- "rule_id": 23224,
- "rule_name": "Discount 15% promo",
- "distribution_type": "individual_items",
- "select_customers"": "targeted",
- "effect_type": "rollback",
- "line": 6,
- "value": 400,
- "coupon_info": {
- "voucher_id": 222,
- "voucher_code": "sale190",
- "coupon_id": 12311,
- "coupon_name": "Sales discount example"
}
}, - {
- "type": "points",
- "effect_type": "rollback",
- "rule_id": 12313,
- "rule_name": "Double points promo Weekends",
- "distribution_type": "individual_items",
- "select_customers"": "targeted",
- "line": 7,
- "value": -200,
- "coupon_info": {
- "voucher_id": 223,
- "voucher_code": "doublepoints",
- "coupon_id": 12312,
- "coupon_name": "Double points campaign"
}
}
], - "rejected_campaigns": [
- {
- "rule_id": 1,
- "rule_name": "€5 total cart",
- "type": "discount",
- "error": "The campaign budget was reached",
- "coupon_info": {
- "voucher_id": 1001,
- "voucher_code": "23222",
- "coupon_id": 3222,
- "coupon_name": "€5 total cart",
- "static_code": "SALES89"
}
}
], - "invalid_coupons": [ ],
- "vouchers": [
- {
- "voucher_id": 13009014,
- "voucher_code": "13993492",
- "discount": 1267,
- "line_order": 1,
- "product_id": 2,
- "rule_id": 2,
- "coupon": {
- "id": 123,
- "key": "discountkeyreferencing internal promo",
- "name": " Discount meat 50%",
- "description": "Discount meat 50% extended description",
- "max_redemptions": 3,
- "min_money": 10.2,
- "max_money": 50.2,
- "min_units": 3,
- "max_units": 8,
- "discount": 0.2,
- "discount_type": "cash",
- "affectation": "activity"
}
}
], - "cashbacks": [
- {
- "line_order": 1,
- "score": 1234,
- "discount": 1267
}
], - "cashback_returns": [
- {
- "line_order": 1,
- "score": 1234
}
], - "scores": [
- {
- "line_order": 1,
- "score": 100,
- "loyalty_score_id": 2,
- "available_from": "2020-01-01",
- "available_to": "2021-01-01"
}
], - "vouchers_desired": [ ],
- "coupons_desired": [ ],
- "promotions": [
- {
- "promotion_id": 1234,
- "discount": 12.6,
- "line_order": 1,
- "product_id": 2
}
], - "attributes": {
- "warranty_selected": true,
- "gift_wrap": false,
- "add_on_ids": [
- 10,
- 20,
- 30
], - "special_instructions": "Handle with care",
- "product_condition": "new",
- "return_policy_applied": true
}, - "additional_costs": {
- "cost1": 1.17,
- "cost2": 2.99,
- "original_cost1": 1.5,
- "original_cost2": 3.5
}
}/activities/simulate is also available as a LEGACY version of this API.
An "Activity" in Loyal Guru represents a cart event.
Purpose of this method (Pre-calculation/Simulation):
This method lets you simulate a new cart (like a purchase) in real-time. It's crucial for Loyalty Points and discount programs and should always be used before finalizing the ticket creation with the POST /activities/realtime method.
Key Uses:
Points and Discounts (coupons_desired property):
By default, all massive and loyalty member promotions (points and discounts) without coupon are included and applied when calculating the ticket.
You can control how vouchers are applied using the coupons_desired property:
all: Apply all masive + loyalty member promotions + all vouchers assigned to the customer.selected: Apply all massive + loyalty member promotions + only vouchers previously selected by the customer via the appropriate endpoint.["34433", "465443"]: apply all massive + loyalty member promotions without coupon + the vouchers/static code specified.[] (empty array) or omit property: Apply only all massive and loyalty member promotions without coupon (no specific vouchers).Cashback Considerations (cashback_score_desired):
If you specify a cashback_score_desired value, you can bypass the manual cashback array calculation. Just provide the total points you wish to redeem. The response will then recommend a cashback array, prioritizing point distribution by line_order based on an internal algorithm.
Note: Specifying this parameter will change the total points and lines in the response compared to your initial request.
Set to -1 to force maximum points usage. The discount applied to a line (from cashback) must not exceed the defined maximum limit of the line's original_total(50% by default).
Important Method Considerations:
total amount of returned lines on the cart is adjusted after applying all relevant discounts, including those from promotional campaigns, vouchers, and any point-based discounts (cashback).original_total attribute.customer_id and customer_code are mutually exclusive; use only one.international: true field will be included in all cart responses.1€ = 10 points and you purchase 2.99€, you earn 29 points.1€ = 1 point and you purchase 12.5€, you earn 12 points.Tier 1 (Critical) — See rate limit table
| id | integer <int64> ID of the cart in form of an integer. |
| code | string Identification |
| location_id | integer <int64> ID of the location in form of an integer. |
| location_code | string Code of the location. |
| customer_id | integer <int64> ID of the customer in form of an integer. Mutually exclusive with |
| customer_code | string Alphanumeric customer code. It must be unique and existing in ours system. Mutually exclusive with |
| creation_date required | string DateTime of the creation of the cart. |
| total required | number Total amount of the purchase cart payed by the customer ( dsscounts applied, taxes included ). If the cart is a cancellation this amount should be negative. The sum of the total values of the activities should be equal to the total sales of the company. |
| original_total | number Original total amount of the purchase cart before any discount or cashback applied before evaluation of the ticket in LG. This value never changes in the different evaluations of the same ticket, and it is used to calculate the total discount applied on the ticket. |
| currency | string Code of the currency acording to the ISO 4217(It must be Capitals letters). In the absence of any information on this point, is going to be filled with the default company currency setup. |
| cashback_score_desired | number The total amount of points that you'd like to spend on the purchase, if specified a cashback array will appear on the response as a recommendation on how should you distribute the score in the different lines. And also, the total of every line will be modifyied acording this array.Use this param or cashbacks array, but you can's use both. If you don't want to deal with specifying exactly the amount of points for the cashback but you'd like to force the maximum redemption of points available for a certain customer, you can specify "-1". |
| vouchers_desired | Array of arrays Deprecated Use coupons_desired instead
By default, all massive and loyalty member promotions (points and discounts) without coupon are included and applied when calculating the ticket.
You can control how vouchers are applied using the
|
| coupons_desired | Array of arrays By default, all massive and loyalty member promotions (points and discounts) are included and applied when calculating the ticket.
You can control how vouchers are applied using the
|
required | Array of objects (LineActivity) Array of lines, at least one is required. |
Array of objects (Cashback) Array of cashbacks. Use this param or cashback_score_desired, but you can's use both. | |
Array of objects (Return) Array of returns. | |
Array of objects (PromotionV2) Array with applied promotions. Important: this is only an informative field, you can't apply a promotion through this field. | |
string or object Deprecated | |
string or object Deprecated | |
string or object Deprecated | |
string or object Deprecated | |
string or object Deprecated | |
string or object Deprecated | |
string or object Deprecated | |
string or object Deprecated | |
| business_name | string The company's corporate name. |
| total_net | number Total amount of money paid by the customer, excluding taxes. |
| total_tax | number Total amount of taxes paid by the customer. |
| tpv_id | string Alphanumeric identifier of the PoS terminal where the cart is made. |
| staff_name | string Name of the person on the PoS terminal. |
| order_id | string Alphanumeric identifier of the order the cart belongs to. |
Array of objects (Payment) Details how the cart amount is paid. | |
object (Shipment) | |
| checkout_date | string DateTime of the checkout of the cart. |
| payment_cost | number Total amount of payment cost paid by the customer. |
| shipping_cost | number Total amount of shipping cost paid by the customer. |
| channel | string Channel from which the cart comes. |
| attributes | object Attributes allow you to store additional data on activities. Uses the JSON Schema Form standard link.
Allowed Data Types:
Attributes must be single-level only with a maximum of 50 attributes and 10KB total size. Example:
|
| additional_costs | object It allows you to store additional costs associated with the cart.
Limits:
Example:
|
| apply_discounts | boolean It allows you to decide whether discounts should be applied to the cart or not. By default, discounts are applied to the cart. If you set this parameter to false, no discount will be applied to the cart, but points discount will be applied if |
| apply_points | boolean It allows you to decide whether points campaigns should be applied to the cart or not. By default, points are given to the customer according to the points campaigns configured in the platform. If you set this parameter to false, no points campaign will be given through the cart. This parameter doesn't affect the redemption of points specified through |
{- "id": 1234,
- "code": "1a2b3c4d",
- "location_id": 12,
- "location_code": "12A",
- "customer_id": 8223,
- "customer_code": "8223a",
- "creation_date": "2016-01-01T23:43:20Z",
- "total": 1234,
- "original_total": 1234,
- "currency": "EUR",
- "cashback_score_desired": 123,
- "vouchers_desired": [
- "selected"
], - "coupons_desired": [
- "selected"
], - "lines": [
- {
- "order": 1,
- "product_id": 345,
- "product_code": "0015SJ1L",
- "product_ean": "GHT567A",
- "total": 12.67,
- "original_total": 12.67,
- "total_cost": 9.67,
- "quantity": 1.2,
- "measurement_unit": "g",
- "total_net": 1200,
- "total_tax": 34,
- "product_name": "Soda juice 1l",
- "product_tax": 21,
- "custom1": "custom value 1",
- "custom2": "custom value 2",
- "custom3": "custom value 3",
- "custom4": "custom value 4",
- "custom5": "custom value 5",
- "custom6": "custom value 6",
- "custom7": "custom value 7",
- "supplier_id": 9876,
- "attributes": {
- "warranty_selected": true,
- "gift_wrap": false,
- "add_on_ids": [
- 10,
- 20,
- 30
], - "special_instructions": "Handle with care",
- "product_condition": "new",
- "return_policy_applied": true
}, - "additional_costs": {
- "cost1": 1.17,
- "cost2": 2.99
}
}
], - "cashbacks": [
- {
- "line_order": 1,
- "score": 1234,
- "discount": 1267
}
], - "returns": [
- {
- "ticket_id": 1234,
- "ticket_code": "1a2b3c4d",
- "line_order": 1,
- "from_line_order": 3,
- "quantity": 1,
- "line_order_change": 1
}
], - "promotions": [
- {
- "promotion_id": 1234,
- "discount": 12.6,
- "line_order": 1,
- "product_id": 2
}
], - "custom1": "custom value",
- "custom2": "custom value",
- "custom3": "custom value",
- "custom4": "custom value",
- "custom5": "custom value",
- "custom6": "custom value",
- "custom7": "custom value",
- "custom8": "custom value",
- "business_name": "SuperMarket S.L. Spain",
- "total_net": 1200,
- "total_tax": 34,
- "tpv_id": "A55",
- "staff_name": "John Doe",
- "order_id": "Order 1234A",
- "payments": [
- {
- "amount": 15,
- "type": "cash",
- "change": 5
}
], - "shipment": {
- "status": "some_status",
- "tracking_code": "some_code",
- "delivery_address": "some_address",
- "company": "some_company",
- "tracking_url": "some_url"
}, - "checkout_date": "2016-01-01T23:43:20Z",
- "payment_cost": 1.5,
- "shipping_cost": 5.5,
- "channel": "online",
- "attributes": {
- "warranty_selected": true,
- "gift_wrap": false,
- "add_on_ids": [
- 10,
- 20,
- 30
], - "special_instructions": "Handle with care",
- "product_condition": "new",
- "return_policy_applied": true
}, - "additional_costs": {
- "cost1": 1.17,
- "cost2": 2.99
}, - "apply_discounts": true,
- "apply_points": false
}{- "id": 123456,
- "code": "ACT-123456",
- "creation_date": "2025-06-01T12:00:00Z",
- "location_id": 98765,
- "total": 100.5,
- "original_total": 150.75,
- "score": 100,
- "score_as_money": 12.65,
- "score_used": 120,
- "score_used_as_money": 12.65,
- "score_returned_from_customer": 12,
- "score_returned_from_customer_as_money": 1.25,
- "score_returned_to_customer": 12,
- "score_returned_to_customer_as_money": 1.25,
- "total_scores_coupon_applied": 116,
- "total_scores_coupon_applied_as_money": 1.16,
- "total_discount_voucher_applied": 11.2,
- "total_discount_applied": 11.2,
- "lines": [
- {
- "order": 1,
- "product_id": 345,
- "product_code": "0015SJ1L",
- "product_ean": "GHT567A",
- "total": 12.67,
- "original_total": 12.67,
- "total_cost": 9.67,
- "quantity": 1.2,
- "measurement_unit": "g",
- "total_net": 1200,
- "total_tax": 34,
- "product_name": "Soda juice 1l",
- "product_tax": 21,
- "custom1": "custom value 1",
- "custom2": "custom value 2",
- "custom3": "custom value 3",
- "custom4": "custom value 4",
- "custom5": "custom value 5",
- "custom6": "custom value 6",
- "custom7": "custom value 7",
- "supplier_id": 9876,
- "attributes": {
- "warranty_selected": true,
- "gift_wrap": false,
- "add_on_ids": [
- 10,
- 20,
- 30
], - "special_instructions": "Handle with care",
- "product_condition": "new",
- "return_policy_applied": true
}, - "additional_costs": {
- "cost1": 1.17,
- "cost2": 2.99
}
}
], - "customer": [
- {
- "id": 1,
- "score": 1234,
- "score_as_money": 12.34,
- "score_available": 1204,
- "score_available_as_money": 12.04,
- "score_threshold_cashback": 1000,
- "score_threshold_cashback_as_money": 100,
- "money_threshold_cashback": 10,
- "score_to_reach_cashback": 100,
- "money_to_spend_to_reach_cashback": 0.1,
- "fraudulent": false,
- "attributes": {
- "loyalty_tier": "gold",
- "customer_score": 850,
- "newsletter_opt_in": true,
- "tags": [
- "vip",
- "premium",
- "early_adopter"
], - "preferred_store_ids": [
- 101,
- 205,
- 308
], - "interests": [
- "electronics",
- "fashion",
- "sports"
]
}
}
], - "effects": [
- {
- "rule_id": 2322,
- "line": 1,
- "rule_name": "Product Discount",
- "type": "discount",
- "effect_type": "percentage",
- "distribution_type": "individual_items",
- "select_customers": "loyalty",
- "value": 100
}, - {
- "rule_id": 2323,
- "line": -1,
- "rule_name": "Holiday Points Bonus",
- "type": "points",
- "effect_type": "direct_value",
- "distribution_type": "total",
- "select_customers": "all_customers",
- "value": 600,
- "value_as_money": 6,
- "available_from": "2025-06-01",
- "available_to": "2026-05-30"
}, - {
- "rule_id": 2324,
- "line": 2,
- "rule_name": "Combo Meal Deal",
- "type": "discount",
- "effect_type": "combo_price",
- "distribution_type": "individual_items_pro_rata",
- "select_customers": "targeted",
- "value": 400,
- "coupon_info": {
- "voucher_id": 111,
- "voucher_code": "4344fjaa",
- "coupon_id": 122211,
- "coupon_name": "Combo Meal Deal"
}
}, - {
- "rule_id": 2325,
- "line": 3,
- "rule_name": "Cashback Offer",
- "type": "points",
- "effect_type": "ratio",
- "distribution_type": "total",
- "select_customers": "loyalty",
- "value": 600,
- "value_as_money": 6,
- "available_from": "2025-06-01",
- "available_to": "2026-05-30"
}, - {
- "type": "discount",
- "rule_id": 23224,
- "rule_name": "Discount 15% promo",
- "distribution_type": "individual_items",
- "select_customers"": "targeted",
- "effect_type": "rollback",
- "line": 6,
- "value": 400,
- "coupon_info": {
- "voucher_id": 222,
- "voucher_code": "sale190",
- "coupon_id": 12311,
- "coupon_name": "Sales discount example"
}
}, - {
- "type": "points",
- "effect_type": "rollback",
- "rule_id": 12313,
- "rule_name": "Double points promo Weekends",
- "distribution_type": "individual_items",
- "select_customers"": "targeted",
- "line": 7,
- "value": -200,
- "coupon_info": {
- "voucher_id": 223,
- "voucher_code": "double points",
- "coupon_id": 12312,
- "coupon_name": "Double points campaign"
}
}
], - "rejected_campaigns": [
- {
- "rule_id": 1,
- "rule_name": "€5 total cart",
- "type": "discount",
- "error": "The campaign budget was reached",
- "coupon_info": {
- "voucher_id": 1001,
- "voucher_code": "23222",
- "coupon_id": 3222,
- "coupon_name": "€5 total cart",
- "static_code": "SALES89"
}
}
], - "invalid_coupons": [ ],
- "vouchers": [
- {
- "voucher_id": 13009014,
- "voucher_code": "13993492",
- "discount": 1267,
- "line_order": 1,
- "product_id": 2,
- "rule_id": 2,
- "coupon": {
- "id": 123,
- "key": "discountkeyreferencing internal promo",
- "name": " Discount meat 50%",
- "description": "Discount meat 50% extended description",
- "max_redemptions": 3,
- "min_money": 10.2,
- "max_money": 50.2,
- "min_units": 3,
- "max_units": 8,
- "discount": 0.2,
- "discount_type": "cash",
- "affectation": "activity"
}
}
], - "cashbacks": [
- {
- "line_order": 1,
- "score": 1234,
- "discount": 1267
}
], - "cashback_returns": [
- {
- "line_order": 1,
- "score": 1234
}
], - "scores": [
- {
- "line_order": 1,
- "score": 100,
- "loyalty_score_id": 2,
- "available_from": "2020-01-01",
- "available_to": "2021-01-01"
}
], - "vouchers_desired": [ ],
- "coupons_desired": [ ],
- "promotions": [
- {
- "promotion_id": 1234,
- "discount": 12.6,
- "line_order": 1,
- "product_id": 2
}
], - "attributes": {
- "warranty_selected": true,
- "gift_wrap": false,
- "add_on_ids": [
- 10,
- 20,
- 30
], - "special_instructions": "Handle with care",
- "product_condition": "new",
- "return_policy_applied": true
}, - "additional_costs": {
- "cost1": 1.17,
- "cost2": 2.99
}
}/activities/{id} is also available as a LEGACY version of this API.
Multicurrency note: if an activity is generated in a country with a currency that is different to the currency of the country that the customer is registered then international = true field will be shown in all the activity responses. In case that both currencies are the same this field will not be shown.
Tier 3 (Low) — See rate limit table
| id required | integer Example: 1234 Activity's id/code value.
|
| search_param | string Example: search_param=id Field used to fetch the activity. Valid values are |
{- "id": 100,
- "currency": "EUR",
- "code": "43433fsss-ihjyw",
- "total": 12,
- "location_id": 120,
- "location_code": "1234567890",
- "customer_id": 100,
- "customer_code": "1234567890",
- "customer": {
- "id": 1,
- "score": 1234,
- "score_as_money": 12.34,
- "score_available": 1204,
- "score_available_as_money": 12.04,
- "score_threshold_cashback": 1000,
- "score_threshold_cashback_as_money": 100,
- "money_threshold_cashback": 10,
- "score_to_reach_cashback": 100,
- "money_to_spend_to_reach_cashback": 0.1,
- "fraudulent": false,
- "attributes": {
- "loyalty_tier": "gold",
- "customer_score": 850,
- "newsletter_opt_in": true,
- "tags": [
- "vip",
- "premium",
- "early_adopter"
], - "preferred_store_ids": [
- 101,
- 205,
- 308
], - "interests": [
- "electronics",
- "fashion",
- "sports"
]
}
}, - "creation_date": "2026-05-27T00:00:00",
- "lines": [
- {
- "order": 1,
- "total": 100,
- "total_net": 1200,
- "quantity": 100,
- "product_code": "ERMP4L3",
- "product_id": 1567567,
- "product_ean": "GHT567A",
- "product_name": "Example product",
- "product_tax": 100,
- "total_cost": 100,
- "original_total": 100,
- "custom1": "tryit",
- "custom2": "custom",
- "custom3": "custom",
- "custom4": "custom",
- "custom5": "custom",
- "custom6": "custom",
- "custom7": "custom",
- "custom9": "custom",
- "measurement_unit": "u",
- "attributes": {
- "warranty_selected": true,
- "gift_wrap": false,
- "add_on_ids": [
- 10,
- 20,
- 30
], - "special_instructions": "Handle with care",
- "product_condition": "new",
- "return_policy_applied": true
}
}
], - "scores": [
- {
- "score": 100,
- "line_order": 12,
- "loyalty_score_id": 12,
- "available_from": "2026-05-01",
- "available_to": "2026-05-27"
}
], - "business_name": "100",
- "payments": [
- {
- "amount": 100,
- "change": 12,
- "type": "cash"
}
], - "score": 100,
- "score_as_money": 12.34,
- "score_used": 120,
- "score_used_as_money": 12.34,
- "score_returned_to_customer": 12,
- "score_returned_to_customer_as_money": 12.34,
- "score_returned_from_customer": 12,
- "score_returned_from_customer_as_money": 12.34,
- "shipment": [
- {
- "status": "1",
- "tracking_code": "1",
- "delivery_address": "1",
- "company": "1",
- "tracking_url": "1",
- "status_histories": [
- {
- "status": "1",
- "created_at": "1"
}
]
}
], - "vouchers_desired": [ ],
- "coupons_desired": [ ],
- "vouchers": [
- {
- "voucher_id": 13009014,
- "voucher_code": "13993492",
- "discount": 1267,
- "line_order": 1,
- "product_id": 2,
- "rule_id": 2,
- "coupon": {
- "id": 123,
- "key": "discountkeyreferencing internal promo",
- "name": " Discount meat 50%",
- "description": "Discount meat 50% extended description",
- "max_redemptions": 3,
- "min_money": 10.2,
- "max_money": 50.2,
- "min_units": 3,
- "max_units": 8,
- "discount": 0.2,
- "discount_type": "cash",
- "affectation": "activity"
}
}
], - "total_discount_voucher_applied": 11.2,
- "total_discount_promotion_applied": 0,
- "total_discount_applied": 11.2,
- "effects": [
- {
- "rule_id": 2322,
- "line": 1,
- "rule_name": "Product Discount",
- "type": "discount",
- "effect_type": "percentage",
- "distribution_type": "individual_items",
- "select_customers": "loyalty",
- "value": 100
}, - {
- "rule_id": 2323,
- "line": -1,
- "rule_name": "Holiday Points Bonus",
- "type": "points",
- "effect_type": "direct_value",
- "distribution_type": "total",
- "select_customers": "all_customers",
- "value": 600,
- "value_as_money": 6,
- "available_from": "2025-06-01",
- "available_to": "2026-05-30"
}, - {
- "rule_id": 2324,
- "line": 2,
- "rule_name": "Combo Meal Deal",
- "type": "discount",
- "effect_type": "combo_price",
- "distribution_type": "individual_items_pro_rata",
- "select_customers": "targeted",
- "value": 400,
- "coupon_info": {
- "voucher_id": 111,
- "voucher_code": "4344fjaa",
- "coupon_id": 122211,
- "coupon_name": "Combo Meal Deal"
}
}, - {
- "rule_id": 2325,
- "line": 3,
- "rule_name": "Cashback Offer",
- "type": "points",
- "effect_type": "ratio",
- "distribution_type": "total",
- "select_customers": "loyalty",
- "value": 600,
- "value_as_money": 6,
- "available_from": "2025-06-01",
- "available_to": "2026-05-30"
}, - {
- "type": "discount",
- "rule_id": 23224,
- "rule_name": "Discount 15% promo",
- "distribution_type": "individual_items",
- "select_customers": "targeted",
- "effect_type": "rollback",
- "line": 6,
- "value": 400,
- "coupon_info": {
- "voucher_id": 222,
- "voucher_code": "sale190",
- "coupon_id": 12311,
- "coupon_name": "Sales discount example"
}
}, - {
- "type": "points",
- "effect_type": "rollback",
- "rule_id": 12313,
- "rule_name": "Double points promo Weekends",
- "distribution_type": "individual_items",
- "select_customers": "targeted",
- "line": 7,
- "value": -200,
- "coupon_info": {
- "voucher_id": 223,
- "voucher_code": "doublepoints",
- "coupon_id": 12312,
- "coupon_name": "Double points campaign"
}
}
], - "rejected_campaigns": [
- {
- "rule_id": 1,
- "rule_name": "€5 total cart",
- "type": "discount",
- "error": "The campaign budget was reached",
- "coupon_info": {
- "voucher_id": 1001,
- "voucher_code": "23222",
- "coupon_id": 3222,
- "coupon_name": "€5 total cart",
- "static_code": "SALES89"
}
}
], - "invalid_coupons": [ ],
- "attributes": {
- "warranty_selected": true,
- "gift_wrap": false,
- "add_on_ids": [
- 10,
- 20,
- 30
], - "special_instructions": "Handle with care",
- "product_condition": "new",
- "return_policy_applied": true
}, - "associate_id": 101,
- "cashbacks": [
- {
- "line_order": 12,
- "score": 100,
- "discount": 4.96
}
], - "total_net": 120,
- "total_tax": 12,
- "custom1": "100",
- "custom2": "100",
- "custom3": "100",
- "custom4": "100",
- "custom5": "100",
- "custom6": "100",
- "custom7": "100",
- "custom8": "100",
- "order_id": 100,
- "score_simulation": true,
- "returns": [
- {
- "ticket_id": 100,
- "ticket_code": "a1b2c34d",
- "score": 100,
- "quantity": 100,
- "line_order": 12,
- "from_line_order": 10,
- "line_order_change": 112
}
], - "cashback_returns": [
- {
- "line_order": 12,
- "score": 100
}
], - "promotions": [
- {
- "promotion_id": 1234,
- "discount": 12.6,
- "line_order": 1,
- "product_id": 2
}
], - "cashback_score_desired": 12,
- "cashback_score_desired_unused": 12,
- "checkout_date": "2016-01-01T23:43:20Z",
- "payment_cost": 1.5,
- "shipping_cost": 5.5,
- "channel": "online",
- "tpv_id": "100",
- "staff_name": "120",
- "staff_code": "12"
}/activities is also available as a LEGACY version of this API.
Multicurrency note: if an activity is generated in a country with a currency that is different to the currency of the country that the customer is registered then international = true field will be shown in all the activity responses. In case that both currencies are the same this field will not be shown.Regarding filters:
id, code can´t be sent at the same time.
customer_id, customer_code and location_id can´t be sent at the same time. Just one of them is allowed.
country and countries are mutually exclusive and cannot be passed together in the same request.
Tier 3 (Low) — See rate limit table
| customer_id | integer <int64> Example: customer_id=99302 Will return all activities by customer. |
| customer_code | string Example: customer_code=99302a Will return all activities by customer code. |
| associate_id | integer <int64> Example: associate_id=99301 Will return all activities by associate. Mutually exclusive with customer_id and customer_code. |
| location_id | integer <int64> Example: location_id=21 Activities in a given location. Mutually exclusive with |
| location_code | string Example: location_code=789B Activities in a given location. Mutually exclusive with |
| order_id | string Example: order_id=order 101 Activities by order. |
| from_date | string Example: from_date=2017-12-31 Activities filter in a given date range, equivalent to session. |
| to_date | string Example: to_date=2018-12-31 Activities filter in a given date range, equivalent to session. |
| id | integer <int64> Example: id=101 Activity by id. Will return only 1 activity as id is unique. Mutually exclusive with |
| code | string Example: code=T1234 Activity by code. Will return only 1 activity as code is unique.
Mutually exclusive with If the code contains special characters (such as
Example: For code |
| per_page | integer <int64> Example: per_page=20 Max number of activities returned per response. - Default: 10 |
| starting_after | string Example: starting_after=token You will receive this token on every response ( on the variable next_token_starts_after ) in order to have the next batch of elements. |
| country | string Example: country=ES Will return all activities by country (single country filtering). ISO 3166-1 alpha-2. Mutually exclusive with |
| countries | string Example: countries=ES,IT Will return all activities by multiple countries (multi-country filtering). ISO 3166-1 alpha-2. Mutually exclusive with |
{- "data": [
- {
- "id": 1234,
- "code": "T1234",
- "barcode": "0012349437",
- "creation_date": "2017-10-16T12:45:55Z",
- "customer_id": 99302,
- "associate_id": 99303,
- "location_id": 43,
- "total": 15.75,
- "international": true,
- "score": 100,
- "score_used": -20,
- "score_returned_from_customer": -20,
- "score_returned_to_customer": 40,
- "business_name": "Streaming Corp",
- "total_net": 14,
- "total_tax": 1.75,
- "tpv_id": "AT123",
- "staff_name": "John Doe",
- "staff_code": "john-doe",
- "currency": "EUR",
- "score_simulation": true,
- "cashback_score_desired": 10,
- "cashback_score_desired_unused": 8,
- "custom1": "custom 1 value",
- "custom2": "custom 2 value",
- "custom3": "custom 3 value",
- "custom4": "custom 4 value",
- "custom5": "custom 5 value",
- "custom6": "custom 6 value",
- "custom7": "custom 7 value",
- "custom8": "custom 8 value",
- "promotions": [
- {
- "promotion_id": 11,
- "product_id": 34,
- "discount": 4.1,
- "line_order": 5,
- "discount_int": 4
}
], - "customer": {
- "id": 99302,
- "code": "99302a",
- "score": 10,
- "score_available": 10,
- "score_as_money": 12.34,
- "score_available_as_money": 12.04,
- "score_threshold_cashback": 1000,
- "money_threshold_cashback": 10,
- "score_to_reach_cashback": 100,
- "money_to_spend_to_reach_cashback": 0.1,
- "fraudulent": false
}, - "payments": [
- {
- "amount": 20,
- "type": "cash",
- "change": 4.25
}
], - "cashbacks": [
- {
- "line_order": 1,
- "score": 100,
- "discount": 8.5
}
], - "scores": [
- {
- "line_order": 1,
- "score": 100,
- "loyalty_score_id": 2,
- "available_from": "2016-01-01"
}
], - "cashback_returns": [
- {
- "line_order": 1,
- "score": 10
}
], - "returns": [
- {
- "line_order": 2,
- "quantity": 5.3,
- "ticket_id": 12,
- "ticket_code": "a1b2c3d4",
- "from_line_order": 1,
- "score": 10
}
], - "lines": [
- {
- "order": 1,
- "total": 15.75,
- "total_net": 14,
- "total_tax": 1.75,
- "total_cost": 16,
- "original_total": 16,
- "price": 16,
- "quantity": 3,
- "product_code": "PR00987L",
- "product_ean": "GHT567A",
- "product_id": 987,
- "product_name": "Product 987 1L",
- "product_tax": 21,
- "custom1": "custom 1 value",
- "custom2": "custom 2 value",
- "custom3": "custom 3 value",
- "custom4": "custom 4 value",
- "custom5": "custom 5 value",
- "custom6": "custom 6 value",
- "custom7": "custom 7 value",
- "custom9": "custom 9 value",
- "attributes": {
- "warranty_selected": true,
- "gift_wrap": false,
- "add_on_ids": [
- 10,
- 20,
- 30
], - "special_instructions": "Handle with care",
- "product_condition": "new",
- "return_policy_applied": true
}
}
], - "shipment": {
- "status": "some_status",
- "tracking_code": "some_code",
- "delivery_address": "some-address",
- "company": "some-company",
- "tracking_url": "some-url",
- "status_histories": [
- {
- "status": "first_status",
- "created_at": "2017-12-25T23:45:55Z"
}, - {
- "status": "second_status",
- "created_at": "2017-12-28T23:45:55Z"
}
]
}, - "rewards": [
- {
- "id": 319,
- "discount": 3.2,
- "line_order": 2,
- "product_id": 12
}
], - "attributes": {
- "warranty_selected": true,
- "gift_wrap": false,
- "add_on_ids": [
- 10,
- 20,
- 30
], - "special_instructions": "Handle with care",
- "product_condition": "new",
- "return_policy_applied": true
}
}
], - "next_token_starts_after": "token"
}This endpoint facilitates the complete reversal of a prior purchase identified by the cart id or cart code.
IMPORTANT!: To cancel a cart correctly and generate a rollback for all vouchers as expected, you must wait at least 5 minutes after the original cart creation. This delay ensures that all asynchronous processes related to points accrual and voucher issuance are completed before initiating the cancellation. If you do not wait this time, there is a risk that some vouchers may not be rolled back correctly.
Purpose. The primary function is to process a full return where the customer cancels the entire cart. This ensures that the system accurately tracks the reversal of inventory, points and redeemed promotions.
Mechanism & Result. Upon successful execution, the system performs the following:
A new order/cart object is generated (often referred to as a "Return Cart").
This new object is a mirror copy of the original cart, but with all product quantities and associated monetary values (including products, coupons, and vouchers) represented as negative amounts.
The original cart is not modified.
The system is then triggered to process the rollback of all earned/used points, vouchers affected and return of stock plus reset of Limits.
Considerations
Tier 3 (Low) — See rate limit table
| cart_to_cancel_id required | integer <int64> Id of the cart to cancel. |
| cart_to_cancel_code required | string Code of the cart to cancel. |
| new_cart_id required | integer <int64> Id of the new cart that is going to be created for the full return. |
| new_cart_code required | string <int64> Code of the new cart that is going to be created for the full return. |
{- "cart_to_cancel_id": 2122322222,
- "cart_to_cancel_code": "ORD12345",
- "new_cart_id": 822323232,
- "new_cart_code": "RET12345"
}{- "id": 1234,
- "code": "1a2b3c4d",
- "location_id": 12,
- "location_code": "12A",
- "customer_id": 8223,
- "customer_code": "8223a",
- "creation_date": "2022-01-01T23:43:20Z",
- "total": -100,
- "currency": "EUR",
- "customer": [
- {
- "id": 1,
- "score": 1234,
- "score_as_money": 12.34,
- "score_available": 1204,
- "score_available_as_money": 12.04,
- "score_threshold_cashback": 1000,
- "score_threshold_cashback_as_money": 100,
- "money_threshold_cashback": 10,
- "score_to_reach_cashback": 100,
- "money_to_spend_to_reach_cashback": 0.1,
- "fraudulent": false,
- "attributes": {
- "loyalty_tier": "gold",
- "customer_score": 850,
- "newsletter_opt_in": true,
- "tags": [
- "vip",
- "premium",
- "early_adopter"
], - "preferred_store_ids": [
- 101,
- 205,
- 308
], - "interests": [
- "electronics",
- "fashion",
- "sports"
]
}
}
], - "score": 100,
- "score_as_money": 12.65,
- "score_used": 120,
- "score_used_as_money": 12.65,
- "score_returned_from_customer": 12,
- "score_returned_from_customer_as_money": 1.25,
- "score_returned_to_customer": 12,
- "score_returned_to_customer_as_money": 1.25,
- "total_scores_coupon_applied": 116,
- "total_scores_coupon_applied_as_money": 1.16,
- "total_discount_voucher_applied": 11.2,
- "total_discount_applied": 11.2,
- "lines": [
- {
- "order": 1,
- "product_id": 345,
- "product_code": "0015SJ1L",
- "product_ean": "GHT567A",
- "total": 12.67,
- "original_total": 12.67,
- "total_cost": 9.67,
- "quantity": 1.2,
- "measurement_unit": "g",
- "total_net": 1200,
- "total_tax": 34,
- "product_name": "Soda juice 1l",
- "product_tax": 21,
- "custom1": "custom value 1",
- "custom2": "custom value 2",
- "custom3": "custom value 3",
- "custom4": "custom value 4",
- "custom5": "custom value 5",
- "custom6": "custom value 6",
- "custom7": "custom value 7",
- "supplier_id": 9876,
- "attributes": {
- "warranty_selected": true,
- "gift_wrap": false,
- "add_on_ids": [
- 10,
- 20,
- 30
], - "special_instructions": "Handle with care",
- "product_condition": "new",
- "return_policy_applied": true
}, - "additional_costs": {
- "cost1": 1.17,
- "cost2": 2.99
}
}
], - "returns": [
- {
- "ticket_id": 1234,
- "ticket_code": "1a2b3c4d",
- "line_order": 1,
- "from_line_order": 3,
- "quantity": 1,
- "line_order_change": 1
}
], - "effects": [
- {
- "type": "discount",
- "effect_type": "rollback",
- "rule_id": 54321,
- "rule_name": "Summer Sale 20% Off",
- "distribution_type": "total_cart",
- "select_customers"": "targeted",
- "value": -15,
- "coupon_info": {
- "voucher_id": 456,
- "voucher_code": "SUMMER20",
- "coupon_id": 65432,
- "coupon_name": "Summer Sale Campaign"
}
}, - {
- "type": "points",
- "effect_type": "rollback",
- "rule_id": 12313,
- "rule_name": "Double points promo Weekends",
- "distribution_type": "individual_items",
- "select_customers"": "targeted",
- "line": 7,
- "value": -200,
- "coupon_info": {
- "voucher_id": 223,
- "voucher_code": "doublepoints",
- "coupon_id": 12312,
- "coupon_name": "Double points campaign"
}
}
], - "cashback_returns": [
- {
- "line_order": 1,
- "score": 1234
}
], - "coupons_desired": [ ],
- "attributes": {
- "warranty_selected": true,
- "gift_wrap": false,
- "add_on_ids": [
- 10,
- 20,
- 30
], - "special_instructions": "Handle with care",
- "product_condition": "new",
- "return_policy_applied": true
}
}/custom_entities is also available as a LEGACY version of this API.
Create a new custom entity
Tier 2 (Moderate) — See rate limit table
| id | string Custom entity identifier. It must be unique. |
| customer_id | integer The numerical identifier of the owner customer. Required if customer_code is not provided. |
| customer_code | string The alphanumeric identifier of the owner customer. Required if customer_id is not provided. |
| slug required | string Custom entity definition identifier. |
| data required | object Custom entity payload. It will be validated against the schema configured for the definition with the provided slug. |
| created_at | string Custom entity date of creation. |
{- "id": "fc12345",
- "customer_id": 123456789,
- "customer_code": "code123456789",
- "slug": "fishing_course",
- "data": {
- "prey_count": 25,
- "location": "BCN"
}, - "created_at": "2023-01-01T12:00:00Z"
}{- "id": "fc12345",
- "customer_id": 123456789,
- "customer_code": "code123456789",
- "slug": "fishing_course",
- "data": {
- "prey_count": 25,
- "location": "BCN"
}, - "created_at": "2023-01-01T12:00:00Z",
- "ingested_at": "2023-11-11T12:00:00Z",
- "score": 700,
- "score_available": 200,
- "scores": [
- {
- "score": 200,
- "loyalty_score_id": 1,
- "available_from": "2023-07-10",
- "available_to": "2023-12-31"
}, - {
- "score": 500,
- "loyalty_score_id": 123,
- "available_from": "2024-01-01",
- "available_to": "2024-12-31"
}
], - "customer": {
- "code": "code123456789",
- "id": 123456789,
- "score": 700,
- "score_available": 200
}
}/custom_entities is also available as a LEGACY version of this API.
Tier 3 (Low) — See rate limit table
| id | string Example: id=asdf12345 Id of the custom entity. |
| customer_id | integer <int64> Example: customer_id=123456789 Id of the owner customer. |
| customer_code | string Example: customer_code=code123456789 Code of the owner customer. |
| slug | string Example: slug=fishing_course Code of the custom entity definition. |
| created_at_gt | string Example: created_at_gt=2023-08-31 If specified, it will return the custom entities created after this date. The format must be ISO 8601 |
| starting_after | string Example: starting_after=token Yo will receive this token on every response ( on the variable next_token_starts_after ) in order to have the next batch of elements. |
{- "data": [
- {
- "id": "fc12345",
- "customer_id": 123456789,
- "customer_code": "code123456789",
- "slug": "fishing_course",
- "data": {
- "prey_count": 25,
- "location": "BCN"
}, - "created_at": "2023-01-01T12:00:00Z",
- "ingested_at": "2023-11-11T12:00:00Z"
}
], - "next_token_starts_after": "token"
}/custom_entities/{id} is also available as a LEGACY version of this API.
Tier 3 (Low) — See rate limit table
| id | string Example: asdf12345 Id of the custom entity. |
{- "id": "fc12345",
- "customer_id": 123456789,
- "customer_code": "code123456789",
- "slug": "fishing_course",
- "data": {
- "prey_count": 25,
- "location": "BCN"
}, - "created_at": "2023-01-01T12:00:00Z",
- "ingested_at": "2023-11-11T12:00:00Z"
}/scores/trigger is also available as a LEGACY version of this API.
This endpoint allows you to programmatically trigger a Points or Wallet campaign when a specific condition is fulfilled.
Customers earn points based on predefined campaigns. These rules can be applied in different scenarios, such as purchases, user sign-ups, or custom events defined by your integration. Accumulated points can later be redeemed for discounts, rewards, or coupons.
Points campaigns can be triggered either by specifying a loyalty rule ID or by using a trigger associated with one or more campaigns.
Important:
Endpoint Versions: There are two versions of this endpoint, depending on the loyalty engine in use.
Version 1: - If multiple loyalty rules are associated with the same trigger, only one rule will be executed. - The rule selection order is not guaranteed. - It is strongly recommended to use the loyalty_rule_id to ensure the correct loyalty rule is triggered.
Version 2: - If multiple loyalty rules are associated with the same trigger, all associated rules will be executed and all points will be granted if conditions are met. - To apply only one rule, you must explicitly specify the loyalty_rule_id.
Additional Considerations:
Tier 1 (Critical) — See rate limit table
| trigger required | string Slug of the trigger associated to the points campaign. |
| customer_id required | number ID of the customer. Mutually exclusive with |
| loyalty_score_id | integer <int64> Deprecated Id of the loyalty rule that you would like to trigger. Use |
| loyalty_rule_id required | integer <int64> Id of the points campaign that you would like to trigger.
It is recommended to always use |
| location_id | number Id of the trigger location. |
| location_code | string Code of the trigger location. |
| score_overwrite | number Overwrite the score given by the campaign. Only makes sense if loyalty_rule_id is provided. If no value, points associated to the campaign will be given. Maximum value allowed: 50000000' |
| comments | string Comments about the trigger transaction. |
| country | string ISO 3166-1 alpha-2 country code (It must be Capitals letters Required for Version 1 engine. For Version 2 engine, if not provided, the customer's registration location country will be used. |
{- "trigger": "manual",
- "customer_id": 10,
- "loyalty_score_id": 12,
- "score_overwrite": 30,
- "comments": "30 extra points for completing the poll"
}{- "customer_code": "string",
- "loyalty_score_id": 12,
- "score": 110,
- "score_as_money": 11,
- "customer": {
- "id": 12,
- "code": "12a",
- "score": 100,
- "score_available": 100
}, - "scores": [
- {
- "loyalty_score_id": 2222,
- "score": 100,
- "available_from": "2025-06-01",
- "available_to": "2026-05-30"
}, - {
- "loyalty_score_id": 1222,
- "score": 10,
- "available_from": "2025-06-01",
- "available_to": "2026-05-30"
}
], - "effects": [
- {
- "rule_id": 2222,
- "rule_name": "Manual points adjustment",
- "type": "points",
- "effect_type": "direct_value",
- "distribution_type": "total",
- "select_customers": "loyalty",
- "value": 100,
- "value_as_money": 10,
- "available_from": "2025-06-01",
- "available_to": "2026-05-30"
}, - {
- "rule_id": 1222,
- "rule_name": "Manual extra points for tier Gold",
- "type": "points",
- "effect_type": "direct_value",
- "distribution_type": "total",
- "select_customers": "loyalty",
- "value": 10,
- "value_as_money": 1,
- "available_from": "2025-06-01",
- "available_to": "2026-05-30"
}
]
}This endpoint allows you to create a new discount campaign.
This process involves creating a Loyalty Campaign and, if the campaign is
configured for targeted customers, an associated Coupon (by providing
coupon_params).
Tier 3 (Low) — See rate limit table
object (CreateNewDiscountsCampaignRequestRuleParams) | |
[...]
